## nodejs 22.22.0+dfsg+~cs22.19.6

=== debian/changelog ===
nodejs (22.22.0+dfsg+~cs22.19.6-1ubuntu3) resolute; urgency=medium

  * Rebuild against latest simdutf

 -- Jeremy Bícha <jbicha@ubuntu.com>  Sun, 08 Feb 2026 10:56:39 -0500

nodejs (22.22.0+dfsg+~cs22.19.6-1ubuntu2) resolute; urgency=medium

  * Apply another upstream fix (PR: #58953) to fix a test failure

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Tue, 20 Jan 2026 14:01:42 +0100

nodejs (22.22.0+dfsg+~cs22.19.6-1ubuntu1) resolute; urgency=medium

  * Merge from Debian unstable. Remaining changes:
    - cherry-pick upstream fix for new icu 78.2

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 19 Jan 2026 06:37:40 +0100

nodejs (22.22.0+dfsg+~cs22.19.6-1) unstable; urgency=medium

  * New upstream version 22.22.0+dfsg+~cs22.19.6
    + CVE-2025-59465 lib: add TLSSocket default error handler
    + CVE-2025-55132 lib: disable futimes when permission model is enabled
    + CVE-2025-55130 lib,permission: require full read and write to symlink APIs
    + CVE-2025-59466 src: rethrow stack overflow exceptions in async_hooks
    + CVE-2025-55131 src,lib: refactor unsafe buffer creation to remove zero-fill toggle
    + CVE-2026-21637 tls: route callback exceptions through error handlers

 -- Jérémy Lal <kapouer@melix.org>  Wed, 14 Jan 2026 01:19:18 +0100

nodejs (22.21.1+dfsg+~cs22.19.0-6ubuntu4) resolute; urgency=medium

  * Revert the test result ignore, new icu has fixed the upstream regressions:
    - Ignore test results, some icu regressions needs to be fixed, but unblock
      for now nodejs
  * Remaining delta: 8464435d688f06f606a0f68917d008fdb5308c2d.patch

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sun, 11 Jan 2026 09:28:26 +0100

nodejs (22.21.1+dfsg+~cs22.19.0-6ubuntu3) resolute; urgency=medium

  * debian/patches/8464435d688f06f606a0f68917d008fdb5308c2d.patch:
    - cherry-pick upstream fix for new icu 78.2

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sat, 10 Jan 2026 17:12:19 +0100

nodejs (22.21.1+dfsg+~cs22.19.0-6ubuntu2) resolute; urgency=medium

  * No-change rebuild for libsimdjson29.

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Thu, 08 Jan 2026 21:24:12 +0000

nodejs (22.21.1+dfsg+~cs22.19.0-6ubuntu1) resolute; urgency=medium

  * Ignore test results, some icu regressions needs to be fixed, but unblock
    for now nodejs

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Tue, 16 Dec 2025 08:23:26 +0100

nodejs (22.21.1+dfsg+~cs22.19.0-6) unstable; urgency=medium

  * Add parallel/test-http-keep-alive-empty-line as flaky
  * Revert "Drop ada component"

 -- Jérémy Lal <kapouer@melix.org>  Mon, 08 Dec 2025 00:23:49 +0100

nodejs (22.21.1+dfsg+~cs22.19.0-5) unstable; urgency=medium

  * Restore libnode127 Breaks/Replaces previous ones.
    Was removed for "nodejs" but this is actually needed
    for transitions to happen. 

 -- Jérémy Lal <kapouer@melix.org>  Fri, 21 Nov 2025 07:48:37 +0100

nodejs (22.21.1+dfsg+~cs22.19.0-4) unstable; urgency=medium

  * More flaky tests on riscv64

 -- Jérémy Lal <kapouer@melix.org>  Wed, 19 Nov 2025 14:12:26 +0100

nodejs (22.21.1+dfsg+~cs22.19.0-3) experimental; urgency=medium

  * patch: upstream commit riscv64. Closes: #1090073

 -- Jérémy Lal <kapouer@melix.org>  Tue, 11 Nov 2025 13:19:34 +0100
