=== debian/changelog ===
nodejs (22.22.0+dfsg+~cs22.19.7-0kali1) kali-experimental; urgency=medium

  * Adapt gbp.conf for Kali
  * Embed amaro for Kali build
  * New upstream version 22.22.0+dfsg+~cs22.19.7
  * Build with amaro support

 -- Sophie Brun <sophie@kali.org>  Mon, 26 Jan 2026 13:56:18 +0100
