## nodejs 22.22.0+dfsg+~cs22.19.13

=== debian/changelog ===
nodejs (22.22.0+dfsg+~cs22.19.13-1) unstable; urgency=medium

  [ Bastien Roucariès ]
  * Increase build timeout
  * Add stricter acorn depends

  [ Jérémy Lal ]
  * New upstream version 22.22.0+dfsg+~cs22.19.13
  * Do not test process.versions
  * Drop ada, use ada-url
  * Disable all nghttp2 tests for now
  * Avoid useless python version check in configure. Closes: #1127459.

 -- Jérémy Lal <kapouer@melix.org>  Thu, 26 Feb 2026 23:26:49 +0100

nodejs (22.22.0+dfsg+~cs22.19.6-2) unstable; urgency=medium

  * Rebuild with newer acorn

 -- Bastien Roucariès <rouca@debian.org>  Tue, 24 Feb 2026 01:14:04 +0100
