## nodejs 24.11.1+dfsg+~cs24.10.1

=== debian/changelog ===
nodejs (24.11.1+dfsg+~cs24.10.1-1) experimental; urgency=medium

  * New upstream version 24.11.1+dfsg+~cs24.10.1
  * Update soname to libnode137
  * Update to ada 3.3.0
  * copyright:
    + exclude more minified files
    + fix many oversights
  * Patch v8 to use shared simdutf
  * Patch to fix 32-bit builds
  * Switch to DEP-14 and simplify Vcs-* fields
  * Can build twice in a row
  * Upstream fix for highway/gcc15 on ppc64el/s390x
  * Improve test timeout multiplier patch
  * Skip new tests depending on amaro

 -- Jérémy Lal <kapouer@melix.org>  Wed, 10 Dec 2025 10:23:07 +0100
