=== debian/control ===
--- 
+++ 
@@ -14,8 +14,6 @@
  curl <!nocheck>,
  gyp (>= 0.16.0~),
  jq,
- libada-url-dev,
- libada-url-dev:native,
  libbrotli-dev,
  libbrotli-dev:native,
  libc-ares-dev (>= 1.18.1~),
@@ -40,7 +38,7 @@
  libssl-dev:native,
  libuv1-dev (>= 1.51.0~),
  libuv1-dev:native,
- node-acorn (>= 8.16.0~) <!pkg.nodejs.nobuiltin>,
+ node-acorn (>= 6.2.1~) <!pkg.nodejs.nobuiltin>,
  node-cjs-module-lexer (>= 1.2.2~) <!pkg.nodejs.nobuiltin>,
  node-minimatch (>= 9.0.3-5) <!pkg.nodejs.nobuiltin>,
  node-undici (>= 5.0.0~) <!pkg.nodejs.nobuiltin>,
@@ -60,8 +58,8 @@
  node-highlight.js <!nodoc>,
 Standards-Version: 4.7.2
 Homepage: https://nodejs.org/
-Vcs-Browser: https://salsa.debian.org/js-team/nodejs/tree/master-22.x
-Vcs-Git: https://salsa.debian.org/js-team/nodejs.git -b master-22.x
+Vcs-Browser: https://salsa.debian.org/js-team/nodejs
+Vcs-Git: https://salsa.debian.org/js-team/nodejs.git
 Rules-Requires-Root: no
 
 Package: libnode-dev
@@ -70,7 +68,7 @@
 Depends: ${misc:Depends},
  libssl-dev (>= 1.1.1~),
  libuv1-dev (>= 1.33.0~),
- libnode127 (= ${binary:Version})
+ libnode137 (= ${binary:Version})
 Breaks: nodejs-dev (<< 10.0.0~dfsg1-3)
 Replaces: libv8-dev,
  nodejs-dev (<< 10.0.0~dfsg1-3)
@@ -83,7 +81,7 @@
  efficient, perfect for data-intensive real-time applications that run
  across distributed devices.
  .
- This package provides development headers for libnode127
+ This package provides development headers for libnode137
 
 Package: nodejs
 Architecture: amd64 arm64 armel armhf i386 mips64el mips64r6el loong64 powerpc ppc64 ppc64el riscv64 s390x
@@ -94,7 +92,7 @@
  node-corepack <!pkg.nodejs.nobuiltin>,
  sse2-support [i386],
  armv6k-support [armel], vfpv2-support [armel],
- libnode127 (= ${binary:Version})
+ libnode137 (= ${binary:Version})
 Recommends: ca-certificates,
  nodejs-doc,
 Suggests: npm
@@ -122,7 +120,7 @@
  System, Events, Standard I/O, Modules, Timers, Child Processes, POSIX,
  HTTP, Multipart Parsing, TCP, DNS, Assert, Path, URL, Query Strings.
 
-Package: libnode127
+Package: libnode137
 Section: libs
 Architecture: amd64 arm64 armel armhf i386 mips64el mips64r6el loong64 powerpc ppc64 ppc64el riscv64 s390x
 Multi-Arch: same
@@ -130,7 +128,7 @@
  ${misc:Depends},
  sse2-support [i386],
  armv6k-support [armel], vfpv2-support [armel],
- node-acorn (>= 8.16.0~) <!pkg.nodejs.nobuiltin>,
+ node-acorn (>= 6.2.1~) <!pkg.nodejs.nobuiltin>,
  node-cjs-module-lexer (>= 1.2.2~) <!pkg.nodejs.nobuiltin>,
  node-minimatch (>= 9.0.3-5) <!pkg.nodejs.nobuiltin>,
  node-undici (>= 5.0.0~) <!pkg.nodejs.nobuiltin>
@@ -140,6 +138,7 @@
  libnode108 (<< 19),
  libnode109 (<< 19),
  libnode115 (<< 21),
+ libnode127 (<< 23),
 Replaces: nodejs-legacy,
  libnode72,
  libnode83,
@@ -147,6 +146,7 @@
  libnode108,
  libnode109,
  libnode115,
+ libnode127,
 Conflicts: nodejs-legacy
 Description: evented I/O for V8 javascript - runtime library
  Node.js is a platform built on Chrome's JavaScript runtime for easily
