=== debian/rules ===
--- 
+++ 
@@ -26,6 +26,7 @@
 --verbose \
 --without-npm \
 --without-corepack \
+--without-amaro \
 --shared \
 --shared-zlib \
 --shared-zstd \
@@ -140,6 +141,13 @@
 skipTests += parallel/test-worker-load-file-with-extension-other-than-js
 skipTests += parallel/test-node-output-sourcemaps
 skipTests += parallel/test-runner-output
+skipTests += parallel/test-runner-global-setup-teardow
+skipTests += parallel/test-runner-run-global-hooks
+skipTests += parallel/test-compile-cache-typescript-commonjs
+skipTests += parallel/test-compile-cache-typescript-esm
+skipTests += parallel/test-compile-cache-typescript-strip-miss
+skipTests += parallel/test-compile-cache-typescript-strip-sourcemaps
+skipTests += parallel/test-compile-cache-typescript-transform
 # tests using npm
 skipTests += parallel/test-npm-install
 skipTests += parallel/test-npm-version
@@ -198,11 +206,3 @@
 flakyTests += parallel/test-stdout-close-unref
 flakyTests += parallel/test-child-process-stdout-flush-exit
 flakyTests += parallel/test-net-connect-options-fd
-flakyTests += sequential/test-fs-watch
-flakyTests += sequential/test-http2-session-timeout
-flakyTests += sequential/test-debugger-preserve-breaks
-flakyTests += sequential/test-debugger-exec-scope
-flakyTests += sequential/test-worker-heapsnapshot-options
-flakyTests += parallel/test-http-keep-alive-empty-line
-# flaky on buildd https://github.com/nodejs/node/issues/39655
-flakyTests += parallel/test-cluster-primary-error
