## nodejs 24.12.0+dfsg+~cs24.10.4

=== debian/changelog ===
nodejs (24.12.0+dfsg+~cs24.10.4-1) experimental; urgency=medium

  * New upstream version 24.12.0+dfsg+~cs24.10.4
  * Refresh patches

 -- Jérémy Lal <kapouer@melix.org>  Sat, 20 Dec 2025 16:18:47 +0100

nodejs (24.11.1+dfsg+~cs24.10.1-2) experimental; urgency=medium

  * Use our typescript.js as fixture for snapshots tests
  * Breaks typescript << 5.2, because node types use new features,
    rendering almost all ts modules uncompilable.

 -- Jérémy Lal <kapouer@melix.org>  Sun, 14 Dec 2025 23:20:47 +0100
