## nodejs 24.13.0%2Bdfsg%2B~cs24.10.7

=== debian/changelog ===
nodejs (24.13.0+dfsg+~cs24.10.7-2) experimental; urgency=medium

  * Properly mention the CVE numbers this version fixes:
    + CVE-2025-59465 lib: add TLSSocket default error handler
    + CVE-2025-55132 lib: disable futimes when permission model is enabled
    + CVE-2025-55130 lib,permission: require full read and write to symlink APIs
    + CVE-2025-59466 src: rethrow stack overflow exceptions in async_hooks
    + CVE-2025-55131 src,lib: refactor unsafe buffer creation to remove zero-fill toggle
    + CVE-2026-21637 tls: route callback exceptions through error handlers

 -- Jérémy Lal <kapouer@melix.org>  Tue, 13 Jan 2026 16:10:31 +0100

nodejs (24.13.0+dfsg+~cs24.10.7-1) experimental; urgency=medium

  * New upstream version 24.13.0+dfsg+~cs24.10.7
  * patch: export libplatform symbols in shared libnode

 -- Jérémy Lal <kapouer@melix.org>  Tue, 13 Jan 2026 15:48:38 +0100
