=== debian/watch ===
--- 
+++ 
@@ -1,7 +1,7 @@
 Version: 5
 
 Source: https://nodejs.org/dist
-Matching-Pattern: v(22\.\d+\.\d+)/
+Matching-Pattern: v(24\.\d+\.\d+)/
 Downloadurlmangle: s/.*v(.*)\//https\:\/\/nodejs\.org\/dist\/v$1\/node\-v$1\.tar\.xz/
 Dversionmangle: auto
 Filenamemangle: s/.*v(.*)\/$/nodejs-$1\.tar\.xz/
@@ -16,5 +16,10 @@
 Template: Npmregistry
 Ctype: nodejs
 Dist: @types/node
-Matching-Pattern: https://registry.npmjs.org/@types/node/-/node-(22\.\d+\.\d+)@ARCHIVE_EXT@
+Matching-Pattern: https://registry.npmjs.org/@types/node/-/node-(24\.\d+\.\d+)@ARCHIVE_EXT@
 Version-Schema: checksum
+
+Component: ada
+Template: Github
+Owner: ada-url
+Project: ada
